CHANGELOG
==========================

## 2.6.4
- Fix possible error when using XenForo Enhanced Search and searching with status IDs.
- Add indexes to ticket table to reduce query time when viewing list of ticketsAdd missing phrase in watched category emails.
- Improve formatting of spam-trigger logs for a user/email when displayed on a ticket.
- Add "Allow images"/"Allow embedded media" ticket permissions. These permissions apply to a user's ticket even after it is posted.

## 2.6.3
- Remove leftover debug code in the previous release.

## 2.6.2
- Fix an issue where additional information for a user awaiting approval would not be displayed.
- Gracefully handle trying to view a category that does not exist.

## 2.6.1
- Fix packaging issue with the previous release.

## 2.6.0
- Require Standard Library by Xon v1.18.0+.
- Add additional search criteria; assigned/assigner of a ticket.
- Support Search Improvements  displaying ticket search terms on the search result page.
- Fix changing status of a ticket did not trigger the search index to be updated.

## 2.5.3
- Fix XF 2.2.12 compatibility when using a captcha with the ticket system.

## 2.5.2
- On fresh install, add a route filter to replace `tickets/` with `support/`.
- Rename "Tickets" navigation tab to "Support".
- Remove ticket title from ticket URLs.
- Fix restricting search to a ticket category.
- Fix guests not being able to see their own moderated replies or tickets.
- Fix not being able to convert a guest's ticket to a thread.
- Hide filtering options for guests viewing tickets they've created.

## 2.5.1
- Allow undeleting ticket messages.
- Harden permission checking around deleted guest tickets.

## 2.5.0
- If a user is awaiting approval, display any recent tickets they've created on the approval queue.
- Display a user's current user state within a ticket.
- Allow staff users with appropriate permissions to approve / reject users awaiting approval.
- Show a proper error when trying to create knowledge base articles when no categories exist.
- Fix upgrade path from XF1 version of the add-on.
- Fix incorrect phrasing on the batch updating tickets page.

## 2.4.0
- Support globally watching the ticket queue.
- Support linking a resource item to a ticket category for users that have permission.
- Always notify users watching a ticket for new replies rather than taking into account last read date.
- Improve quick search integration.
- Implement searching within a ticket.
- Implement searching by category.
- Implement searching by status.
- Fix search not searching ticket titles.
- Actually implement inline moderation support for ticket search results.
- Fix incorrect positioning of predefined responses menu when using an RTL language.

## 2.3.4
- Require StandardLib v1.5.0+, as this implements the template filter `replacevalue`
- Support 64bit `xf_ip.ip_id` column.
- Support linking a ticket category to a resource category.
- Add Sort button to ticket priority and status lists.
- Add spam cleaner support.
- Fixes inactive priorities/statuses could be assigned to a ticket on edit.
- Fixes the "Alerts are sent when a ticket transitions to this status" flag was not respected
- Fixes editing a ticket's title to a falsy value.

## 2.3.3
- Add batch update tickets functionality to admin panel.
- Add category option to disable new tickets / messages.
- Fixes attachment handling for new tickets.

## 2.3.2
- Fixes for converting a conversation/thread to a ticket.
- Fixes for converting a ticket to a thread, this includes incorrect assignment of the first post in the thread's IP.
- Enable shadow-ban function even if most spam checks are disabled.
- Reduce over-fetching of tickets when viewing a category.
- Reduce queries from redundant ticket counter rebuilds.
- Use XF cache backend where applicable for ticket last read date.

## 2.3.1
- Add support for value pruning for fields that are editable only once.
- Force global namespace for functions which are known to be optimizable to bytecode in php, or known global functions to avoid a current namespace lookup for the function.
- Implement warnings for ticket messages.
- Fix incorrect column definition for match types on ticket fields.
- Fix API missing permission check for setting prefix on a ticket.
- Fix ticket discussion threads would not correctly attach to a ticket. Installer will resync desync'ed ticket/discussion thread pairs.
- Don't show flash message when rerouting the contact form.
- Don't duplicate captcha display when a guest is creating a ticket.

## 2.3.0
- Add ability to ban specific emails from Ticket system.
- Add "shadow ban" feature, by an explicit email list or for tickets which contain too few words.
- Add ability to copy ticket user's email to clipboard, if the visitor can see it.
- Add additional filters for showing tickets based on whether they are unassigned, assigned to self or assigned to others.
- Fix an issue with BB code rendering when using predefined responses.
- Ensure the captcha displays when replying or creating a ticket.
- Fix non-functional draft support for new tickets. 
- Improve behaviour of various input fields whilst using RTL languages.

## 2.2.5
- Ensure last ticket message in ticket list view is anonymized.
- Add "Set status on soft-deleted" feature to automatically set the status to non-open on soft-delete.

## 2.2.4
- Ensure action bar menu items collapse in to a menu at smaller viewports.
- Add an option (defaulted off) to display signatures on ticket messages.
- Ensure various status icons are displayed when listing tickets.
- Fix an issue when trying to prune contents of fields that did not exist anymore.
- Fix undefined "errorKey" when doing guest username validation.
- Ensure guest username is handled correctly when inviting to the ticket.
- Improve performance of XF1.x to XF2.x update when converting various fields to JSON.
- Fix an issue preventing predefined responses from being used when BB code is disabled in the editor.

## 2.2.3
- Allow banned users to utilise the ticket system.
- Add inverted criteria options.
- If transitioning to a status will send an alert, indicate this to staff users.
- Add the ability to have user and moderator editable fields as well as preventing them from being edited.
- Add the ability to select available custom fields when editing categories.
- When converting a thread to a ticket, check if the thread starter still exists instead of throwing an error.
- Fix view logic before ticket password check blocking guest access to a ticket.
- Improve handling of guest password entry.
- Fix inbound email processor not correctly handling malformed emails.
- Fix exporting conversation/thread to ticket if IP records have been pruned.
- Enforce requiring an email for guest tickets.
- Add missing bookmark item template for ticket messages.
- Fix ticket responses not being correctly set in editor when they contain BB code.
- Fix escalation criteria "Time passed since last reply/ticket is greater/less than" check so it's not inverted.
- Fix non-moderators not being able to view new ticket counts in moderator bar.

## 2.2.2
- Fix ticket change thread form not linking to the thread.
- Fix ticket discussion thread not displaying ticket tabs bar.
- Harden installer and fix possible issues upgrading from XF1, a MySQL 8.0 compatibility issue and duplicate columns.
- Fix invite/create ticket notification not working as expected.
- Support inviting/creating a ticket and notifying the user anonymously.
- Added ticket status/priority/category to escalation criteria.

## 2.2.1
- Switch to XenForo 2.2's new way of previewing editor contents.
- Fix per ticket category "count messages" option not being respected for new tickets.
- Compatibility fix for ElasticSearch Essentials when updating Tickets add-on.
- Prevent truncating of category descriptions when displaying the category list for ticket creation.
- Enforce requirement for Standard Library.

## 2.2.0
- Require XenForo 2.2+.
- Require PHP 7.2+.
- Add the ability for users with permission to anonymise their responses to tickets as a particular user.
- Add support for LinkableInterface.
- Return additional data when retrieving ticket information via the API.
- Add per ticket category "count messages" option.
- Improve search accuracy when non-viewable search categories exist
- Fix discussion thread creation may not occur, or may occur under the wrong user