# Tickets
Tickets is a support system solution for XenForo 2 aiming to collate all your helpdesk needs in to one easy to use solution.

### Features:
- Allow users to create new tickets in configurable categories. Custom permissions allow you greater control over who can see a ticket and who can respond to them.
   - Categories can setup email addresses to receive tickets and associated replies.
- Sophisticated guest support allowing non-users to create tickets and receive responses and notifications from them.
   - Guest tickets are protected by a password and this needs to be entered before a ticket can be read.
   - Once a guest is authenticated against a ticket, they're able to view that ticket until their session expires.
   - Guests can also view a reduced ticket list when they're authenticated against multiple tickets similar to how normal users would.
   - Got a guest that made a couple tickets but then registered and made some more? All of these can be merged and attached to the user account they created.
- Custom fields allowing you to capture the data you want to receive from your end users.
- Escalations make it easier than ever to automate common and mundane tasks.
   - Automatically resolve tickets where the end user hasn't responded in over two weeks or remind a user via emails or alerts about their open tickets, for example.
   - Fine-grain criteria and background processing can open up the door to complex automation rules without massive overhead.
   - Default criteria not cutting it? Extend the add-on and add your own with little work.
- Integration with XenForo core functionality.
   - End users receive alerts and emails when their tickets get responded to, keeping them in the loop constantly.
   - Categories, tickets and even specific users can be watched to get notifications when a ticket (or other event) gets triggered.
   - Inline moderation controls to perform bulk actions on tickets.
   - Tickets and ticket messages get pushed to the search index letting you quickly dig up old relics.
- Read tracking for guests and users.
- Multiple, custom, states to track the progress of each ticket.
- Predefined responses to keep your staff member tone consistent across messages and tickets. Automatically inject information about the ticket being responded to and its starter, in to the response itself letting you avoid awkward situations.
- Optional and customisable priority selection letting you prioritise user tickets based on the severity. Priorities (and other ticket information) can be changed dynamically with escalations for further automation.
- Simplified layout letting users differentiate between a ticket and thread with ease.