<?php
/*
if (PHP_SAPI !== 'cli')
{
    exit();
}
*/

@set_time_limit(5);
ignore_user_abort(true);

$dir = __DIR__;
require($dir . '/src/XF.php');

XF::start($dir);
/** @var \XF\Pub\App $app */
$app = XF::setupApp('XF\Pub\App');

if (\XF::$versionId === $app->options()->currentVersionId || !$app->config('checkVersion'))
{
    $result = null;
    if (PHP_SAPI === 'cli')
    {
        $data = file_get_contents("php://stdin");
    }
    else
    {
        $data = $_POST['email'] ?? null;
    }
    // silently return
    if (!$data)
    {
        echo "OK\n";
        return;
    }

    // TODO; ticket category to bind too
    $categoryId = null;
    if (!$categoryId)
    {
        return;
    }
    /** @var \NF\Tickets\SubContainer\TicketEmail $ticketEmailContainer */
    $ticketEmailContainer = $this->app->container('nfTicketsEmail');

    /** @var \NF\Tickets\Entity\Category $ticketCategory */
    $ticketCategory = $this->app->em()->find('NF\Tickets:Category', $this->data['category']);

    if (!$ticketCategory)
    {
        return;
    }

    $processor = $ticketEmailContainer->processor($ticketCategory);
    $finished = $processor->processMessage($data);
    echo "OK\n";
}