var NF = window.NF || {};
NF.Tickets = NF.Tickets || {};

!function ($, window, document, _undefined)
{
	"use strict";

	NF.Tickets.QuickResponses = XF.Element.newHandler({

		options: {
			ticketId: null
		},

		init: function ()
		{
			$(this.$target).select2({
				dir: XF.isRtl() ? "rtl" : "ltr"
			});
			this.$target.change(XF.proxy(this, 'responseSelected'));
		},

		responseSelected: function (e)
		{
			var responseId = parseInt(this.$target.val());

			if (responseId)
			{
				XF.ajax('get', XF.canonicalizeUrl('index.php?tickets/response'), {
					'response_id': this.$target.val(),
					'ticket_id': this.options.ticketId
				}, XF.proxy(this, 'handleResponse'));
			}
		},

		handleResponse: function (data)
		{
			this.$target.val(0).trigger('change');

			var self = this;
			XF.setupHtmlInsert(data.content, function ($html, container, onComplete)
			{
				XF.insertIntoEditor(
					self.$target.closest('form'),
					data.messageHtml,
					data.message
				);
			});
		}
	});

	XF.Element.register('quick-response-select', 'NF.Tickets.QuickResponses');

}(jQuery, window, document);