var NF = window.NF || {};
NF.Tickets = NF.Tickets || {};

!function ($, window, document, _undefined) {
	"use strict";

	NF.Tickets.TicketReplyRefresh = XF.Element.newHandler({
		init: function () {
			this.$target.on('ajax-submit:response', XF.proxy(this, 'afterSubmit'));
		},

		afterSubmit: function (e, data) {
			if (data.errors || data.exception)
			{
				return;
			}

			if (data.hasOwnProperty('ticketInfoHtml')) {
				var ticketInfoBlock = this.getTicketInfoBlock();

				XF.setupHtmlInsert(data.ticketInfoHtml, function ($html, container, onComplete) {
                    ticketInfoBlock.replaceWith($html);
				});
			}

			if (data.hasOwnProperty('handleTicketHtml')) {
                var handleTicketBlock = this.getHandleTicketBlock();

                XF.setupHtmlInsert(data.handleTicketHtml, function ($html, container, onComplete) {
                    handleTicketBlock.replaceWith($html);
                });
            }
		},

		getTicketInfoBlock: function () {
			return $('.js-ticketInfoSidebar').first();
		},

        getHandleTicketBlock: function () {
            return $('.js-handleTicketSidebar').first();
        }
	});

	NF.Tickets.ReplyActions = XF.Click.newHandler({

		eventNameSpace: 'NFTReplyActionsClick',
		options: {
			'status': 0
		},

		init: function() {},

		click: function(e)
		{
			$('input[name=reply_ticket_state]').val(this.options.status);
			$('.js-quickReply').submit();
		}
	});

	XF.Element.register('ticket-quick-reply', 'NF.Tickets.TicketReplyRefresh');
	XF.Click.register('reply-action', 'NF.Tickets.ReplyActions');

}(jQuery, window, document);