<?php

namespace NF\Tickets\Api\Controller;

use XF\Api\Controller\AbstractController;
use XF\Mvc\Entity\Entity;
use XF\Mvc\ParameterBag;

class Ticket extends AbstractController
{
	protected function preDispatchController($action, ParameterBag $params)
	{
		$this->assertApiScope('nf_ticket');
	}

	public function actionGet(ParameterBag $params)
	{
		$ticket = $this->assertViewableTicket($params->ticket_id);
		$this->assertRegisteredUser(); // TODO: soon

		$result = [
			'ticket' => $ticket->toApiResult(Entity::VERBOSITY_VERBOSE)
		];
		return $this->apiResult($result);
	}

	/**
     * @param int     $id
     * @param array   $with
     * @param ?string $phraseKey
     * @throws \XF\Mvc\Reply\Exception
	 * @return \NF\Tickets\Entity\Ticket
	 */
	protected function assertViewableTicket(int $id, array $with = ['api'], string $phraseKey = null): \NF\Tickets\Entity\Ticket
	{
        /** @noinspection PhpIncompatibleReturnTypeInspection */
        return $this->assertViewableApiRecord('NF\Tickets:Ticket', $id, $with, $phraseKey);
	}
}