<?php

namespace NF\Tickets\Api\ControllerPlugin;

use XF\Api\ControllerPlugin\AbstractPlugin;

class Ticket extends AbstractPlugin
{
	public function applyTicketFilters(\NF\Tickets\Finder\Ticket $ticketFinder, \NF\Tickets\Entity\Category $category = null)
	{
		$filters = [];

		$prefixId = $this->filter('prefix_id', 'uint');
		if ($prefixId)
		{
			$ticketFinder->where('prefix_id', $prefixId);
			$filters['prefix_id'] = $prefixId;
		}

		return $filters;
	}

	public function applyTicketSort(\NF\Tickets\Finder\Ticket $ticketFinder, \NF\Tickets\Entity\Category $category = null)
	{
		$order = $this->filter('order', 'str');
		if (!$order)
		{
			return null;
		}

		$direction = $this->filter('direction', 'str');
		if ($direction !== 'asc')
		{
			$direction = 'desc';
		}

		switch ($order)
		{
			case 'priority':
			case 'last_message_date':
			case 'last_modified_date':
			case 'start_date':
			case 'title':
				$ticketFinder->order($order, $direction);
				return [$order, $direction];
		}

		return null;
	}
}