<?php

namespace NF\Tickets\Entity;

use XF\Entity\AbstractFieldMap;
use XF\Mvc\Entity\Structure;

/**
 * COLUMNS
 * @property int $ticket_category_id
 * @property string $field_id
 *
 * RELATIONS
 * @property \NF\Tickets\Entity\TicketField $Field
 * @property \NF\Tickets\Entity\Category $Category
 */
class CategoryField extends AbstractFieldMap
{
    /**
     * @return string
     */
    public static function getContainerKey()
    {
        return 'ticket_category_id';
    }

    /**
     * @param Structure $structure
     * @return Structure
     */
    public static function getStructure(Structure $structure)
    {
        self::setupDefaultStructure(
            $structure,
            'xf_nf_tickets_category_field',
            'NF\Tickets:CategoryField',
            'NF\Tickets:TicketField'
        );

        $structure->relations['Category'] = [
            'entity'     => 'NF\Tickets:Category',
            'type'       => self::TO_ONE,
            'conditions' => 'ticket_category_id',
            'primary'    => true,
        ];

        return $structure;
    }
}