<?php

namespace NF\Tickets\Entity;

use XF\Entity\AbstractPrefixMap;
use XF\Mvc\Entity\Structure;

/**
 * COLUMNS
 * @property int $ticket_category_id
 * @property int $prefix_id
 *
 * RELATIONS
 * @property \NF\Tickets\Entity\TicketPrefix $Prefix
 * @property \NF\Tickets\Entity\Category $Category
 */
class CategoryPrefix extends AbstractPrefixMap
{
    public static function getContainerKey()
    {
        return 'ticket_category_id';
    }

    public static function getStructure(Structure $structure)
    {
        self::setupDefaultStructure($structure, 'xf_nf_tickets_category_prefix', 'NF\Tickets:CategoryPrefix', 'NF\Tickets:TicketPrefix');

        $structure->relations['Category'] = [
            'entity' => 'NF\Tickets:Category',
            'type' => self::TO_ONE,
            'conditions' => 'ticket_category_id',
            'primary' => true
        ];

        return $structure;
    }
}