<?php

namespace NF\Tickets\Entity;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;

/**
 * COLUMNS
 * @property int $ticket_id
 * @property string $field_id
 * @property string $field_value
 * @property bool $is_expired
 *
 * RELATIONS
 * @property \NF\Tickets\Entity\TicketField $Field
 */
class TicketFieldValue extends Entity
{
	/**
	 * @param Structure $structure
	 *
	 * @return Structure
	 */
	public static function getStructure(Structure $structure)
	{
		$structure->table = 'xf_nf_tickets_ticket_field_value';
		$structure->shortName = 'NF\Tickets:TicketFieldValue';
		$structure->primaryKey = ['ticket_id', 'field_id'];
		$structure->columns = [
			'ticket_id' => ['type' => self::UINT, 'required' => true],
			'field_id' => ['type' => self::STR, 'maxLength' => 25, 'match' => 'alphanumeric'],
			'field_value' => ['type' => self::STR, 'default' => ''],
			'is_expired' => ['type' => self::BOOL, 'default' => false],
		];
		$structure->getters = [];
		$structure->relations = [
			'Field' => [
				'entity' => 'NF\Tickets:TicketField',
				'type' => self::TO_ONE,
				'conditions' => 'field_id',
				'primary' => true,
			],
		];

		return $structure;
	}
}