<?php

namespace NF\Tickets\Entity;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;

/**
 * COLUMNS
 * @property int|null $ticket_id
 * @property int $user_id
 * @property int $last_read_date
 *
 * RELATIONS
 * @property \NF\Tickets\Entity\Ticket $Ticket
 * @property \XF\Entity\User $User
 */
class TicketParticipant extends Entity
{
    public static function getStructure(Structure $structure)
    {
        $structure->table = 'xf_nf_tickets_ticket_participant';
        $structure->shortName = 'NF\Tickets:TicketParticipant';
        $structure->primaryKey = ['ticket_id', 'user_id'];
        $structure->columns = [
            'ticket_id'      => ['type' => self::UINT, 'required' => true, 'nullable' => true],
            'user_id'        => ['type' => self::UINT, 'required' => true],
            'last_read_date' => ['type' => self::UINT, 'default' => 0],
        ];
        $structure->getters = [];
        $structure->relations = [
            'Ticket' => [
                'entity'     => 'NF\Tickets:Ticket',
                'type'       => self::TO_ONE,
                'conditions' => 'ticket_id',
                'primary'    => true,
            ],
            'User'   => [
                'entity'     => 'XF:User',
                'type'       => self::TO_ONE,
                'conditions' => 'user_id',
                'primary'    => true,
            ],
        ];

        return $structure;
    }

}