<?php

namespace NF\Tickets\Entity;

use XF\Entity\AbstractPrefixGroup;
use XF\Mvc\Entity\Structure;

/**
 * COLUMNS
 * @property int|null $prefix_group_id
 * @property int $display_order
 *
 * GETTERS
 * @property \XF\Phrase|string $title
 *
 * RELATIONS
 * @property \XF\Entity\Phrase $MasterTitle
 * @property \XF\Mvc\Entity\AbstractCollection|\NF\Tickets\Entity\TicketPrefix[] $Prefixes
 */
class TicketPrefixGroup extends AbstractPrefixGroup
{
    protected function getClassIdentifier()
    {
        return 'NF\Tickets:TicketPrefix';
    }

    protected static function getContentType()
    {
        return 'nf_tickets_ticket';
    }

    public static function getStructure(Structure $structure)
    {
        self::setupDefaultStructure(
            $structure,
            'xf_nf_tickets_ticket_prefix_group',
            'NF\Tickets:TicketPrefixGroup',
            'NF\Tickets:TicketPrefix'
        );

        return $structure;
    }
}