<?php

namespace NF\Tickets\Entity;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;

/**
 * COLUMNS
 * @property int|null $ticket_read_id
 * @property int $user_id
 * @property int $ticket_id
 * @property int $ticket_read_date
 *
 * RELATIONS
 * @property \XF\Entity\User $User
 * @property \NF\Tickets\Entity\Ticket $Ticket
 */
class TicketRead extends Entity
{
    /**
     * @param Structure $structure
     * @return Structure
     */
    public static function getStructure(Structure $structure)
    {
        $structure->table = 'xf_nf_tickets_ticket_read';
        $structure->shortName = 'NF\Tickets:TicketRead';
        $structure->primaryKey = 'ticket_read_id';
        $structure->columns = [
            'ticket_read_id'   => ['type' => self::UINT, 'autoIncrement' => true, 'nullable' => true],
            'user_id'          => ['type' => self::UINT, 'required' => true],
            'ticket_id'        => ['type' => self::UINT, 'required' => true],
            'ticket_read_date' => ['type' => self::UINT, 'required' => true],
        ];
        $structure->getters = [];
        $structure->relations = [
            'User'   => [
                'entity'     => 'XF:User',
                'type'       => self::TO_ONE,
                'conditions' => 'user_id',
                'primary'    => true,
            ],
            'Ticket' => [
                'entity'     => 'NF\Tickets:Ticket',
                'type'       => self::TO_ONE,
                'conditions' => 'ticket_id',
                'primary'    => true,
            ],
        ];

        return $structure;
    }
}