<?php

namespace NF\Tickets\Entity;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;

/**
 * COLUMNS
 * @property int $user_id
 * @property int $ticket_id
 * @property bool $email_subscribe
 *
 * RELATIONS
 * @property \NF\Tickets\Entity\Ticket $Ticket
 * @property \XF\Entity\User $User
 */
class TicketWatch extends Entity
{
    /**
     * @param Structure $structure
     * @return Structure
     */
    public static function getStructure(Structure $structure)
    {
        $structure->table = 'xf_nf_tickets_ticket_watch';
        $structure->shortName = 'NF\Tickets:TicketWatch';
        $structure->primaryKey = ['user_id', 'ticket_id'];
        $structure->columns = [
            'user_id'         => ['type' => self::UINT, 'required' => true],
            'ticket_id'       => ['type' => self::UINT, 'required' => true],
            'email_subscribe' => ['type' => self::BOOL, 'default' => false],
        ];
        $structure->getters = [];
        $structure->relations = [
            'Ticket' => [
                'entity'     => 'NF\Tickets:Ticket',
                'type'       => self::TO_ONE,
                'conditions' => 'ticket_id',
                'primary'    => true,
            ],
            'User'   => [
                'entity'     => 'XF:User',
                'type'       => self::TO_ONE,
                'conditions' => 'user_id',
                'primary'    => true,
            ],
        ];

        return $structure;
    }
}