<?php

namespace NF\Tickets\Finder;

use XF\Mvc\Entity\Finder;

/**
 * Class Ticket
 *
 * @package NF\Tickets\Finder
 */
class Status extends Finder
{
    /**
     * @param bool $check
     * @param \NF\Tickets\Entity\Status|int|null $forceIncludeStatus
     *
     * @return $this
     */
    public function isActive($check = true, $forceIncludeStatus = null)
    {
        if ($forceIncludeStatus)
        {
            if ($forceIncludeStatus instanceof \NF\Tickets\Entity\Status)
            {
                $forceIncludeStatus = $forceIncludeStatus->status_id;
            }

            $this->whereOr(['active', $check], ['status_id', $forceIncludeStatus]);
        }
        else
        {
            $this->where('active', '=', $check);
        }

        return $this;
    }

    /**
     * @param bool $check
     * @return $this
     */
    public function isClose($check)
    {
        $this->where('is_close', '=', $check);

        return $this;
    }

    /**
     * @param bool $check
     * @return $this
     */
    public function isCounted($check = true)
    {
        $this->where('include_in_counts', '=', $check);

        return $this;
    }

    /**
     * @param bool $check
     * @return $this
     */
    public function isIncludedInDefaultTicketList($check = true)
    {
        $this->where('include_in_defaults', '=', $check);

        return $this;
    }
}