<?php

namespace NF\Tickets\Import\Data;

use XF\Import\Data\AbstractEmulatedData;

/**
 * Class Category
 *
 * @package NF\Tickets\Import\Data
 */
class Category extends AbstractEmulatedData
{
    /**
     * @return string
     */
    public function getImportType()
    {
        return 'category';
    }

    /**
     * @return string
     */
    public function getEntityShortName()
    {
        return 'NF\Tickets:Category';
    }

    /**
     * @param $oldId
     * @param $newId
     */
    protected function postSave($oldId, $newId)
    {
        \XF::runOnce('nfTicketsCategoryImport', function()
        {
            /** @var \XF\Service\RebuildNestedSet $service */
            $service = \XF::service('XF:RebuildNestedSet', 'NF\Tickets:Category', [
                'parentField' => 'parent_category_id',
            ]);
            $service->rebuildNestedSetInfo();
        });
    }
}