<?php

namespace NF\Tickets\Import\Data;

use XF\Import\Data\AbstractEmulatedData;
use XF\Import\Data\HasDeletionLogTrait;

class Message extends AbstractEmulatedData
{
    use HasDeletionLogTrait;

    protected $loggedIp;

    public function getImportType()
    {
        return 'message';
    }

    protected function getEntityShortName()
    {
        return 'NF\Tickets:Message';
    }

    public function setLoggedIp($loggedIp)
    {
        $this->loggedIp = $loggedIp;
    }

    protected function preSave($oldId)
    {
        $this->forceNotEmpty('username', $oldId);
        $this->forceNotEmpty('message', $oldId);

        if (empty($this->user_name))
        {
            $this->user_name = $this->username;
        }
    }

    protected function postSave($oldId, $newId)
    {
        $this->logIp($this->loggedIp, $this->message_date);
        $this->insertStateRecord($this->message_state, $this->message_date);
    }
}