<?php

namespace NF\Tickets\Import\Data;

use XF\Import\Data\AbstractEmulatedData;

class Status extends AbstractEmulatedData
{
    protected $title = '';

    public function getImportType()
    {
        return 'status';
    }

    protected function getEntityShortName()
    {
        return 'NF\Tickets:Status';
    }

    public function setTitle($title)
    {
        $this->title = $title;
    }

    protected function postSave($oldId, $newId)
    {
        /** @var \NF\Tickets\Entity\Status $status */
        $status = $this->em()->find('NF\Tickets:Status', $newId);
        if ($status)
        {
            $this->insertMasterPhrase($status->getPhraseName(), $this->title);

            $this->em()->detachEntity($status);
        }
    }
}