<?php

namespace NF\Tickets\Import\Data;

use XF\Import\Data\AbstractField;

class TicketField extends AbstractField
{
    protected $categoryIds = [];

    public function getImportType()
    {
        return 'ticket_field';
    }

    protected function getEntityShortName()
    {
        return 'NF\Tickets:TicketField';
    }

    public function setCategories(array $categoryIds)
    {
        $this->categoryIds = $categoryIds;
    }

    protected function postSave($oldId, $newId)
    {
        parent::postSave($oldId, $newId);

        if ($this->categoryIds)
        {
            $insert = [];
            foreach ($this->categoryIds AS $categoryId)
            {
                $insert[] = [
                    'ticket_category_id' => $categoryId,
                    'field_id' => $newId
                ];
            }

            $this->db()->insertBulk('xf_nf_tickets_category_field', $insert, false, false, 'IGNORE');
        }
    }
}