<?php

namespace NF\Tickets\Import\Data;

use XF\Import\Data\AbstractEmulatedData;

class TicketPrefixGroup extends AbstractEmulatedData
{
    protected $title = '';

    public function getImportType()
    {
        return 'ticket_prefix_group';
    }

    protected function getEntityShortName()
    {
        return 'NF\Tickets:TicketPrefixGroup';
    }

    public function setTitle($title)
    {
        $this->title = $title;
    }

    protected function postSave($oldId, $newId)
    {
        /** @var \NF\Tickets\Entity\TicketPrefixGroup $group */
        $group = $this->em()->find('NF\Tickets:TicketPrefixGroup', $newId);
        if ($group)
        {
            $this->insertMasterPhrase($group->getPhraseName(), $this->title);

            $this->em()->detachEntity($group);
        }
    }
}