<?php

namespace NF\Tickets\Import\DataHelper;

use XF\Import\DataHelper\AbstractHelper;

class Category extends AbstractHelper
{
    public function importCategoryWatch($categoryId, $userId, array $config = [])
    {
        $this->importCategoryWatchBulk($categoryId, [$userId => $config]);
    }

    public function importCategoryWatchBulk($categoryId, array $userConfigs)
    {
        $insert = [];

        foreach ($userConfigs AS $userId => $config)
        {
            $insert[] = [
                'user_id' => $userId,
                'ticket_category_id' => $categoryId,
                'notify_on' => empty($config['notify_on']) ? '' : $config['notify_on'],
                'send_alert' => empty($config['send_alert']) ? 0 : 1,
                'send_email' => empty($config['send_email']) ? 0 : 1,
                'include_children' => 0
            ];
        }

        if ($insert)
        {
            $this->db()->insertBulk(
                'xf_nf_tickets_category_watch',
                $insert,
                false,
                'notify_on = VALUES(notify_on), send_alert = VALUES(send_alert), send_email = VALUES(send_email), include_children = VALUES(include_children)'
            );
        }
    }
}