<?php

namespace NF\Tickets\Import\DataHelper;

use XF\Import\DataHelper\AbstractHelper;

use function is_scalar;

class Ticket extends AbstractHelper
{
    public function importTicketWatch($ticketId, $userId, $email = false)
    {
        $this->importTicketWatchBulk($ticketId, [$userId => $email]);
    }

    public function importTicketWatchBulk($ticketId, array $userConfigs)
    {
        $insert = [];

        foreach ($userConfigs AS $userId => $config)
        {
            if (is_scalar($config))
            {
                $config = ['email_subscribe' => (bool)$config];
            }

            $insert[] = [
                'user_id' => $userId,
                'ticket_id' => $ticketId,
                'email_subscribe' => empty($config['email_subscribe']) ? 0 : 1
            ];
        }

        if ($insert)
        {
            $this->db()->insertBulk(
                'xf_nf_tickets_ticket_watch',
                $insert,
                false,
                'email_subscribe = VALUES(email_subscribe)'
            );
        }
    }
}