<?php

namespace NF\Tickets\Job;

use XF\Job\AbstractRebuildJob;

class Category extends AbstractRebuildJob
{
    protected function getNextIds($start, $batch)
    {
        $db = $this->app->db();

        return $db->fetchAllColumn($db->limit("
                SELECT ticket_category_id
                FROM xf_nf_tickets_category
                WHERE ticket_category_id > ?
                ORDER BY ticket_category_id
            ", $batch
        ), $start);
    }

    protected function rebuildById($id)
    {
        /** @var \NF\Tickets\Entity\Category $category */
        $category = $this->app->em()->find('NF\Tickets:Category', $id);
        if ($category)
        {
            $category->rebuildCounters();
            $category->save();
        }
    }

    protected function getStatusType()
    {
        return \XF::phrase('nf_tickets_ticket_categories');
    }
}