<?php

namespace NF\Tickets\Job;

use XF\Job\AbstractRebuildJob;

class PruneFields extends AbstractRebuildJob
{
	protected function getNextIds($start, $batch)
	{
		$db = $this->app->db();

		return $db->fetchAllColumn($db->limit("
                SELECT ticket_id
				FROM xf_nf_tickets_ticket
				WHERE ticket_id > ?
				AND custom_fields <> '[]'
				ORDER BY ticket_id
            ", $batch
		), $start);
	}

	protected function rebuildById($id)
	{
		/** @var \NF\Tickets\Entity\Ticket $ticket */
		$ticket = $this->app->em()->find('NF\Tickets:Ticket', $id);
		if ($ticket)
		{
			/** @var \NF\Tickets\Repository\Ticket $ticketRepo */
			$ticketRepo = $this->app->repository('NF\Tickets:Ticket');
			$ticketRepo->pruneTicketFields($ticket);
		}
	}

	protected function getStatusType()
	{
		return \XF::phrase('nf_tickets_expired_ticket_field_values');
	}
}