<?php

namespace NF\Tickets\Job;

use XF\Job\AbstractRebuildJob;

class PruneShadowBannedTickets extends AbstractRebuildJob
{
    protected function getNextIds($start, $batch)
    {
        $db = $this->app->db();

        $shadowBanRetention = (int)(\XF::options()->nftPurgeShadowBanned ?? -1);
        if ($shadowBanRetention < 0)
        {
            return [];
        }
        $offset = \XF::$time - $shadowBanRetention * 86400;

        return $db->fetchAllColumn($db->limit("
                SELECT ticket_id
                FROM xf_nf_tickets_ticket
                WHERE ticket_id > ? AND discussion_state = 'shadow_ban' AND start_date < ?
                ORDER BY ticket_id
            ", $batch
        ), [$start, $offset]);
    }

    protected function rebuildById($id)
    {
        /** @var \NF\Tickets\Entity\Ticket $ticket */
        $ticket = $this->app->em()->find('NF\Tickets:Ticket', $id);
        if ($ticket)
        {
            $ticket->delete(false);
        }
    }

    protected function getStatusType()
    {
        return \XF::phrase('nf_tickets_tickets');
    }
}