<?php

namespace NF\Tickets\Job;

use XF\Job\AbstractRebuildJob;

class Ticket extends AbstractRebuildJob
{
    protected $defaultData = [
        'anonymized' => false,
    ];

    protected function getNextIds($start, $batch)
    {
        $db = $this->app->db();

        if ($this->data['anonymized'] ?? false)
        {
            return $db->fetchAllColumn($db->limit("
                SELECT ticket.ticket_id
                FROM xf_nf_tickets_ticket as ticket
                JOIN xf_nf_tickets_message as message ON (message.message_id = ticket.last_message_id)
                WHERE ticket.ticket_id > ? AND message.ticket_id = ticket.ticket_id AND message.anonymized = 1 
                ORDER BY ticket.ticket_id
            ", $batch
            ), $start);
        }

        return $db->fetchAllColumn($db->limit("
                SELECT ticket_id
                FROM xf_nf_tickets_ticket
                WHERE ticket_id > ?
                ORDER BY ticket_id
            ", $batch
        ), $start);
    }

    protected function rebuildById($id)
    {
        /** @var \NF\Tickets\Entity\Ticket $ticket */
        $ticket = $this->app->em()->find('NF\Tickets:Ticket', $id);
        if ($ticket)
        {
            $ticket->rebuildCounters();
            $ticket->save();
        }
    }

    protected function getStatusType()
    {
        return \XF::phrase('nf_tickets_tickets');
    }
}