<?php

namespace NF\Tickets\Job;

use XF\Job\AbstractRebuildJob;

class UserTicketCount extends AbstractRebuildJob
{
    protected function getNextIds($start, $batch)
    {
        $db = $this->app->db();

        return $db->fetchAllColumn($db->limit("
                SELECT user_id
                FROM xf_user
                WHERE user_id > ?
                ORDER BY user_id
            ", $batch
        ), $start);
    }

    protected function rebuildById($id)
    {
        /** @var \NF\Tickets\Repository\Ticket $repo */
        $repo = $this->app->repository('NF\Tickets:Ticket');
        $count = $repo->getUserTicketCount($id);

        $this->app->db()->update('xf_user', ['nf_tickets_count' => $count], 'user_id = ?', $id);
    }

    protected function getStatusType()
    {
        return \XF::phrase('nf_tickets_ticket_counts');
    }
}