<?php

class NixFifty_Tickets_DataWriter_TicketResponse extends XenForo_DataWriter
{
    protected $_existingDataErrorPhrase = 'nf_tickets_requested_response_not_found';

    protected function _getFields()
    {
        return [
            'xf_nixfifty_ticket_response' => [
                'response_id'          => ['type' => self::TYPE_UINT, 'autoIncrement' => true],
                'user_id'              => ['type' => self::TYPE_UINT, 'default' => 0],
                'response_title'       => ['type' => self::TYPE_STRING, 'required' => true],
                'response_category_id' => ['type' => self::TYPE_UINT, 'required' => true, 'default' => 0],
                'message'              => ['type' => self::TYPE_STRING, 'default' => ''],
                'active'               => ['type' => self::TYPE_UINT, 'default' => 1],
                'display_order'        => ['type' => self::TYPE_UINT, 'default' => 10],
            ],
        ];
    }

    protected function _getExistingData($data)
    {
        if (!$id = $this->_getExistingPrimaryKey($data, 'response_id'))
        {
            return false;
        }

        return ['xf_nixfifty_ticket_response' => $this->_getResponseModel()->getResponseById($id)];
    }

    protected function _getUpdateCondition($tableName)
    {
        return 'response_id = ' . $this->_db->quote($this->getExisting('response_id'));
    }

    /**
     * @return NixFifty_Tickets_Model_Response
     */
    protected function _getResponseModel()
    {
        return $this->getModelFromCache('NixFifty_Tickets_Model_Response');
    }
}
