<?php

class NixFifty_Tickets_DataWriter_TicketResponseCategory extends XenForo_DataWriter
{
    protected function _getFields()
    {
        return [
            'xf_nixfifty_ticket_response_category' => [
                'response_category_id' => ['type' => self::TYPE_UINT, 'autoIncrement' => true],
                'category_name'        => ['type' => self::TYPE_STRING, 'required' => true],
                'display_order'        => ['type' => self::TYPE_UINT, 'required' => true, 'default' => 10],
            ],
        ];
    }

    protected function _getExistingData($data)
    {
        if (!$id = $this->_getExistingPrimaryKey($data))
        {
            return false;
        }

        return ['xf_nixfifty_ticket_response_category' => $this->_getResponseModel()->getCategoryById($id)];
    }

    protected function _getUpdateCondition($tableName)
    {
        return 'response_category_id = ' . $this->_db->quote($this->getExisting('response_category_id'));
    }

    /**
     * @return NixFifty_Tickets_Model_Response
     */
    protected function _getResponseModel()
    {
        return $this->getModelFromCache('NixFifty_Tickets_Model_Response');
    }
}
