<?php

namespace NF\Tickets\Option;

use XF\Option\AbstractOption;

class DefaultPriority extends AbstractOption
{
    public static function renderOption(\XF\Entity\Option $option, array $htmlParams)
    {
        /** @var \NF\Tickets\Repository\Priority $priorityRepo */
        $priorityRepo = \XF::repository('NF\Tickets:Priority');
        $priorities = $priorityRepo->getPriorityKeyValues(true);

        return self::getSelectRow($option, $htmlParams, $priorities);
    }

    public static function verifyOption(&$value, \XF\Entity\Option $option)
    {
        if (!$value)
        {
            $value = 0;

            return true;
        }

        /** @var \NF\Tickets\Repository\Priority $priorityRepo */
        $priorityRepo = \XF::repository('NF\Tickets:Priority');
        /** @var \NF\Tickets\Entity\Priority $priority */
        $priority = $priorityRepo->findPrioritiesForList(false)->whereId($value)->fetchOne();
        if (!$priority)
        {
            $option->error(\XF::phrase('nf_tickets_priority_not_found'), $option->option_id);

            return false;
        }
        else if (!$priority->active)
        {
            $option->error(\XF::phrase('nf_tickets_priority_not_active'), $option->option_id);

            return false;
        }

        return true;
    }
}