<?php

namespace NF\Tickets\Option;

use XF\Option\AbstractOption;

class DefaultStatus extends AbstractOption
{
    public static function renderOption(\XF\Entity\Option $option, array $htmlParams)
    {
        /** @var \NF\Tickets\Repository\Status $statusRepo */
        $statusRepo = \XF::repository('NF\Tickets:Status');
        $statuses = $statusRepo->getStatusTitlePairs();

        return self::getSelectRow($option, $htmlParams, $statuses);
    }

    public static function verifyOption(&$value, \XF\Entity\Option $option)
    {
        if (!$value)
        {
            $value = null;

            return true;
        }

        /** @var \NF\Tickets\Repository\Status $statuses */
        $statuses = \XF::repository('NF\Tickets:Status');
        /** @var \NF\Tickets\Entity\Status $status */
        $status = $statuses->findStatusesForList(false)->whereId($value)->fetchOne();
        if (!$status)
        {
            $option->error(\XF::phrase('nf_tickets_status_not_found'), $option->option_id);

            return false;
        }
        else if (!$status->active)
        {
            $option->error(\XF::phrase('nf_tickets_status_not_active'), $option->option_id);

            return false;
        }

        return true;
    }
}