<?php

namespace NF\Tickets\Pub\View\Response;

use XF\Mvc\Renderer\Json as JsonResponseRenderer;
use XF\Mvc\View;
use XF\App as BaseApp;
use XF\SubContainer\BbCode as BbCodeSubContainer;
use XF\Mvc\Renderer\AbstractRenderer as AbstractResponseRenderer;

class Get extends View
{
    /**
     * @version 2.2.6
     *
     * @return array
     */
	public function renderJson()
	{
        return $this->getHtmlOutputStructure($this->params['message']);
	}

    /**
     * @since 2.2.6
     *
     * @param string $message
     *
     * @return array
     */
	protected function getHtmlOutputStructure(string $message) : array
    {
        /** @var JsonResponseRenderer $render */
        $render = $this->renderer();
        $placeholder = \XF::generateRandomString(5);

        return \array_merge($render->getHtmlOutputStructure($placeholder), [
            'message' => $message,
            'messageHtml' => $this->getMessageHtml($message)
        ]);
    }

    /**
     * @version 2.2.6
     *
     * @param string $message
     *
     * @return string
     */
	protected function getMessageHtml(string $message): string
	{
	    return $this->bbCode()->render($message, 'editorHtml', 'editor', null);
	}

    /**
     * @since 2.2.6
     *
     * @return AbstractResponseRenderer
     */
	protected function renderer() : AbstractResponseRenderer
    {
        return $this->renderer;
    }

	protected function app(): BaseApp
	{
		return \XF::app();
	}

	protected function bbCode(): BbCodeSubContainer
	{
		return $this->app()->bbCode();
	}
}