<?php

namespace NF\Tickets\Repository;

use XF\Repository\AbstractFieldMap;

/**
 * Class CategoryField
 *
 * @package NF\Tickets\Repository
 */
class CategoryField extends AbstractFieldMap
{
    /**
     * @return string
     */
    protected function getMapEntityIdentifier()
    {
        return 'NF\Tickets:CategoryField';
    }

    /**
     * @param \XF\Entity\AbstractField $field
     * @return mixed
     */
    protected function getAssociationsForField(\XF\Entity\AbstractField $field)
    {
        return $field->getRelation('CategoryFields');
    }

    /**
     * @param array $cache
     */
    protected function updateAssociationCache(array $cache)
    {
        $categoryIds = \array_keys($cache);
        $categories = $this->em->findByIds('NF\Tickets:Category', $categoryIds);

        foreach ($categories AS $category)
        {
            /** @var \NF\Tickets\Entity\Category $category */
            $category->field_cache = $cache[$category->ticket_category_id];
            $category->saveIfChanged();
        }
    }
}