<?php

namespace NF\Tickets\Repository;

use XF\Repository\AbstractPrefixMap;

class CategoryPrefix extends AbstractPrefixMap
{
    protected function getMapEntityIdentifier()
    {
        return 'NF\Tickets:CategoryPrefix';
    }

    protected function getAssociationsForPrefix(\XF\Entity\AbstractPrefix $prefix)
    {
        return $prefix->getRelation('CategoryPrefixes');
    }

    protected function updateAssociationCache(array $cache)
    {
        $ids = \array_keys($cache);
        $categories = $this->em->findByIds('NF\Tickets:Category', $ids);

        foreach ($categories AS $category)
        {
            /** @var \NF\Tickets\Entity\Category $category */
            $category->prefix_cache = $cache[$category->ticket_category_id];
            $category->saveIfChanged();
        }
    }
}