<?php

namespace NF\Tickets\Repository;

use XF\Repository\AbstractCategoryTree;

/**
 * Class Category
 *
 * @package NF\Tickets\Repository
 */
class KBCategory extends AbstractCategoryTree
{
    /**
     * @return string
     */
    protected function getClassName()
    {
        return 'NF\Tickets:KBCategory';
    }

    public function mergeCategoryListExtras(array $extras, array $childExtras)
    {
        $output = \array_merge([
            'article_count' => 0,
            'childCount'    => 0,
        ], $extras);

        foreach ($childExtras AS $child)
        {
            if (!empty($child['article_count']))
            {
                $output['article_count'] += $child['article_count'];
            }
            $output['childCount'] += 1 + (!empty($child['childCount']) ? $child['childCount'] : 0);
        }

        return $output;
    }
}