<?php

namespace NF\Tickets\Repository;

use XF\Mvc\Entity\Repository;

class Priority extends Repository
{
    public function getActivePriority(int $priorityId): ?\NF\Tickets\Entity\Priority
    {
        /** @var \NF\Tickets\Entity\Priority $priority */
        /** @noinspection PhpUnnecessaryLocalVariableInspection */
        $priority = $this->findPrioritiesForList()
                         ->isActive()
                         ->whereId($priorityId)
                         ->fetchOne();

        return $priority;
    }

    /**
     * @param bool $activeOnly
     * @return \NF\Tickets\Finder\Priority
     */
    public function findPrioritiesForList($activeOnly = true)
    {
        /** @var \NF\Tickets\Finder\Priority $finder */
        $finder = $this->finder('NF\Tickets:Priority')
                       ->setDefaultOrder('display_order');

        if ($activeOnly)
        {
            $finder->isActive();
        }

        return $finder;
    }

    public function getPriorityKeyValues($includeNone = false)
    {
        $data = [];
        if ($includeNone)
        {
            $data[0] = \XF::phrase('(none)');
        }
        $priorities = $this->findPrioritiesForList()->fetch();
        /**
         * @var \NF\Tickets\Entity\Priority $priority
         */
        foreach ($priorities as $id => $priority)
        {
            $data[$id] = $priority->title;
        }

        return $data;
    }
}