<?php

namespace NF\Tickets\Repository;

use XF\Repository\AbstractField;

/**
 * Class TicketField
 *
 * @package NF\Tickets\Repository
 */
class TicketField extends AbstractField
{
	/**
	 * @return string
	 */
	protected function getRegistryKey()
	{
		return 'nfTicketFields';
	}

	/**
	 * @return string
	 */
	protected function getClassIdentifier()
	{
		return 'NF\Tickets:TicketField';
	}

	/**
	 * @return array
	 */
	public function getDisplayGroups()
	{
		return [
			'sidebar_ticket_info' => \XF::phrase('nf_tickets_sidebar_ticket_info'),
			'sidebar_user_info' => \XF::phrase('nf_tickets_sidebar_user_info'),
			'above_message' => \XF::phrase('nf_tickets_above_message'),
			'below_message' => \XF::phrase('nf_tickets_below_message'),
			'new_tab' => \XF::phrase('nf_tickets_own_tab'),
		];
	}

	public function getFieldTypes($forDisplay = false)
	{
		$types = parent::getFieldTypes($forDisplay);

		$method = $forDisplay ? 'phrase' : 'phraseDeferred';

		$types['callback'] = [
			'label' => \XF::$method('php_callback'),
			'type' => 'callback',
			'compatible' => '',
			'options' => '',
		];

		return $types;
	}
}