<?php

namespace NF\Tickets\Service\BannedEmails;

use XF\Service\AbstractXmlImport;

use function in_array;

class Import extends AbstractXmlImport
{
    public function import(\SimpleXMLElement $xml)
    {
        /** @var \NF\Tickets\Repository\Banning $repo */
        $repo = $this->repository('NF\Tickets:Banning');

        $bannedEmailsCache = $repo->findEmailBans()->fetch()->keys();
        $bannedEmailsCache = \array_map('strtolower', $bannedEmailsCache);

        $entries = $xml->entry;
        foreach ($entries AS $entry)
        {
            if (in_array(\strtolower((string)$entry['banned_email']), $bannedEmailsCache, true))
            {
                // already exists
                continue;
            }

            $repo->banEmail(
                (string)$entry['banned_email'],
                (bool)($entry['shadow_ban'] ?? true),
                \XF\Util\Xml::processSimpleXmlCdata($entry->reason)
            );
        }
    }
}