<?php

namespace NF\Tickets\XF\ApprovalQueue;

use XF\Entity\ApprovalQueue;

/**
 * Extends \XF\ApprovalQueue\User
 */
class User extends XFCP_User
{
	public function getTemplateData(ApprovalQueue $unapprovedItem)
	{
		$response = parent::getTemplateData($unapprovedItem);

        /** @var \NF\Tickets\XF\Entity\User $visitor */
        $visitor = \XF::visitor();
        if (!$visitor->canAccessTicketQueue())
        {
            return $response;
        }

		/** @var \XF\Entity\User $user */
		$user = $unapprovedItem->Content;

		/** @var \NF\Tickets\Finder\Ticket $ticketFinder */
		$ticketFinder = \XF::app()->finder('NF\Tickets:Ticket');

		$tickets = $ticketFinder
			->with('Category')
			->with('Category.Permissions|' . \XF::visitor()->permission_combination_id)
			->where('starter_user_id', $user->user_id)
			->order('last_message_date', 'desc')
			->fetch(5);
        $tickets = $tickets->filterViewable();

		$response['tickets'] = $tickets;

		return $response;
	}
}