<?php

namespace NF\Tickets\XF\Pub\Controller;

use XF\Mvc\ParameterBag;
use XF\Mvc\Reply\AbstractReply;

/**
 * Extends \XF\Pub\Controller\GotoPage
 */
class GotoPage extends XFCP_GotoPage
{
    protected $ticketAction = false;
    protected function preDispatchType($action, ParameterBag $params)
    {
        $actionL = \preg_replace('#[^a-z0-9]#i', ' ', $action);
        $actionL = \str_replace(' ', '', \strtolower($actionL));
        if ($actionL === 'ticketmessage')
        {
            $this->ticketAction = true;
            /** @var \NF\Tickets\ControllerPlugin\Ticket $plugin */
            $plugin = $this->plugin('NF\Tickets:Ticket');
            $plugin->preDispatchForTicket($this->isDiscouraged(), $action, $params);
        }

        parent::preDispatchType($action, $params);
    }

    protected function postDispatchType($action, ParameterBag $params, AbstractReply &$reply)
    {
        if ($this->ticketAction)
        {
            /** @var \NF\Tickets\ControllerPlugin\Ticket $plugin */
            $plugin = $this->plugin('NF\Tickets:Ticket');
            $plugin->postDispatchForTicket($action, $params, $reply);
        }

        parent::postDispatchType($action, $params, $reply);
    }

    /** @var null|bool */
    protected $isDiscouraged = null;

    protected function isDiscouraged()
    {
        if ($this->isDiscouraged !== null)
        {
            return $this->isDiscouraged;
        }
        $this->isDiscouraged = parent::isDiscouraged();

        return $this->isDiscouraged;
    }

    public function actionTicketMessage(ParameterBag $params)
    {
        $params->offsetSet('message_id', $this->filter('id', 'uint'));

        return $this->rerouteController('NF\Tickets:Message', 'index', $params);
    }
}