<?php

namespace NF\Tickets\XF\Service\User;

use NF\Tickets\Entity\TicketGuestParticipant;

class Registration extends XFCP_Registration
{
    protected function _save()
    {
        $user = parent::_save();

        $this->migrateGuestTicketParticipators();

        return $user;
    }

    protected function migrateGuestTicketParticipators()
    {
        /** @var TicketGuestParticipant[] $participating */
        $participating = $this->finder('NF\Tickets:TicketGuestParticipant')->where('email', $this->user->email)->fetch();

        \XF::db()->beginTransaction();

        foreach ($participating AS $item)
        {
            \XF::db()->beginTransaction();
            $item->delete(true, false);

            $newParticipantRecord = $item->Ticket->getNewParticipant($this->user);
            $newParticipantRecord->save(true, false);
            \XF::db()->commit();
        }

        \XF::db()->commit();
    }
}