<?php

namespace NF\Tickets\XFRM\Admin\Controller;

/**
 * Extends \XFRM\Admin\Controller\Category
 */
class Category extends XFCP_Category
{
	public function categoryAddEdit(\XFRM\Entity\Category $category)
	{
		$reply = parent::categoryAddEdit($category);

		if ($reply instanceof \XF\Mvc\Reply\View)
		{
			/** @var \NF\Tickets\Repository\Category $ticketCategoryRepo */
			$ticketCategoryRepo = $this->repository('NF\Tickets:Category');
			$reply->setParam('nfTicketCategories', $ticketCategoryRepo->getCategoryOptionsData());
		}

		return $reply;
	}

	protected function categorySaveProcess(\XFRM\Entity\Category $category)
	{
		$form = parent::categorySaveProcess($category);

		$form->setup(function () use ($category)
		{
			$category->nf_tickets_category_id = $this->filter('nf_tickets_category_id', 'uint');
		});

		return $form;
	}
}