<?php

namespace NF\Tickets\XFRM\Entity;

use NF\Tickets\Entity\Category as TicketCategory;
use XF\Mvc\Entity\Structure;

/**
 * Extends \XFRM\Entity\Category
 *
 * @property int|null            $nf_tickets_category_id
 * @property-read TicketCategory $TicketCategory
 */
class Category extends XFCP_Category
{
    /**
     * @param Structure $structure
     * @return Structure
     */
    public static function getStructure(Structure $structure)
    {
        $structure = parent::getStructure($structure);

		$structure->columns['nf_tickets_category_id'] = ['type' => self::UINT, 'nullable' => true];

		$structure->relations['TicketCategory'] = [
			'entity' => 'NF\Tickets:Category',
			'type' => self::TO_ONE,
			'conditions' => [
				['ticket_category_id', '=', '$nf_tickets_category_id']
			],
			'primary' => true
		];
    
        return $structure;
    }
}