<?php

namespace NF\Tickets\XFRM\Pub\Controller;

use NF\Tickets\XF\Entity\User;
use XF\Mvc\ParameterBag;

/**
 * Extends \XFRM\Pub\Controller\Category
 */
class Category extends XFCP_Category
{
	public function actionAdd(ParameterBag $params)
	{
		$reply = parent::actionAdd($params);

        /** @var User $visitor */
		$visitor = \XF::visitor();

		if ($reply instanceof \XF\Mvc\Reply\View && $visitor->canAccessTicketQueue())
		{
			/** @var \NF\Tickets\Repository\Category $ticketCategoryRepo */
			$ticketCategoryRepo = $this->repository('NF\Tickets:Category');
			$reply->setParam('nfTicketCategories', $ticketCategoryRepo->getCategoryOptionsData());
		}

		return $reply;
	}

	protected function setupResourceCreate(\XFRM\Entity\Category $category)
	{
		$creator = parent::setupResourceCreate($category);

        /** @var User $visitor */
		$visitor = \XF::visitor();
		if ($visitor->canAccessTicketQueue())
		{
			$creator->getResource()->nf_tickets_category_id = $this->filter('nf_tickets_category_id', 'uint');
		}

		return $creator;
	}
}