<?php

namespace NF\Tickets\XFRM\Pub\Controller;

use NF\Tickets\XF\Entity\User;
use XF\Mvc\ParameterBag;

/**
 * Extends \XFRM\Pub\Controller\ResourceItem
 */
class ResourceItem extends XFCP_ResourceItem
{
	public function actionEdit(ParameterBag $params)
	{
		$reply = parent::actionEdit($params);

        /** @var User $visitor */
		$visitor = \XF::visitor();

		if ($reply instanceof \XF\Mvc\Reply\View && $visitor->canAccessTicketQueue())
		{
			/** @var \NF\Tickets\Repository\Category $ticketCategoryRepo */
			$ticketCategoryRepo = $this->repository('NF\Tickets:Category');
			$reply->setParam('nfTicketCategories', $ticketCategoryRepo->getCategoryOptionsData());
		}

		return $reply;
	}

	protected function setupResourceEdit(\XFRM\Entity\ResourceItem $resource)
	{
		$editor = parent::setupResourceEdit($resource);

        /** @var User $visitor */
		$visitor = \XF::visitor();
		if ($visitor->canAccessTicketQueue())
		{
			$editor->getResource()->nf_tickets_category_id = $this->filter('nf_tickets_category_id', 'uint');
		}

		return $editor;
	}
}